

/*=====   checkWand()   ====================================================*
 *                                                                          *
 *    Catch user input from wand.                                           *
 *                                                                          *
 *    This function contains example code for using the CAVE-X Event        *
 *      functions in a CAVE program. Call this function from CAVE           *
 *      program's frame update function.                                    *
 *                                                                          *
 *      This code has been contributed by:                                  *
 *        Alan Verlo (EVL-UIC)    7.94, 11.94                               *
 *        Richard Gillilan (Cornell Univ)    7.94                           *
 *                                                                          *
 *==========================================================================*
 */

void  checkWand(void)
{
    static int not_lowered = 1;
    static int pushed = 0; 
    float x0, y0, z0, x1, y1, z1, xs, ys;
    int xp, yp;


    /*  sample and save user input from wand  */
    CAVEGetWand(x0,y0,z0); 
    CAVEGetWandFront(x1,y1,z1);


    /*  ... do other wand and user stuff ...  */


    /*  only use X events with CAVE, do NOT use with simulator  */
#ifdef  USE_XEVENTS

    x1 += x0; y1 += y0; z1 += z0;

    /*  this assumes screen is z = -5  */
    /*  position X cursor by wand vector  */
    xs = -(z1+5)/(z1-z0)*(x1-x0)+x0;
    ys = -(z1+5)/(z1-z0)*(y1-y0)+y0;
    xp =  (int) 1280 * (xs+5.0)/10.0;
    yp =  (int) 1024 * (10.0-ys)/10.0;

    moveXcursor(xp,yp); 

    /*  use button 3 double-click to push windows  */
    if (dclick3 && not_lowered)  {
        not_lowered = 0;   
        lowerXwindow();
        dclick3 = 0;
    }

    else if (!dclick3)
        not_lowered = 1;

    /*  use right wand button to push X buttons  */
    if ((button3 == ON) && (button2 == OFF) && !pushed) {
        pushed = 1;
        pushXbutton(); 
        releaseXbutton(); 
    }

    else if ((button3 == OFF) && (button2 == OFF) && pushed)
        pushed = 0;

#endif

    return;
    
}  /*  end checkWand()  */
